Topological data scripting: Difference between revisions

From FreeCAD Documentation
(Changed H3 to H2 and H4 to H3 in 'Boolean Operations')
(Minor edits to 'Exploring shapes'.)
(16 intermediate revisions by the same user not shown)
Line 13: Line 13:


==Introduction== <!--T:2-->
==Introduction== <!--T:2-->

Here we will explain to you how to control the [[Part_Module|Part Module]] directly from the FreeCAD Python interpreter, or from any external script. The basics about Topological data scripting are described in [[Part_Module#Explaining_the_concepts|Part Module Explaining the concepts]]. Be sure to browse the [[Scripting]] section and the [[FreeCAD_Scripting_Basics]] pages if you need more information about how Python scripting works in FreeCAD. If you are new to Python, it is a good idea to first read the [[Introduction_to_Python|Introduction to Python]].
Here we will explain to you how to control the [[Part_Module|Part Module]] directly from the FreeCAD Python interpreter, or from any external script. The basics about Topological data scripting are described in [[Part_Module#Explaining_the_concepts|Part Module Explaining the concepts]]. Be sure to browse the [[Scripting]] section and the [[FreeCAD_Scripting_Basics]] pages if you need more information about how Python scripting works in FreeCAD. If you are new to Python, it is a good idea to first read the [[Introduction_to_Python|Introduction to Python]].


===Class Diagram=== <!--T:3-->
===Class diagram=== <!--T:3-->

This is a [http://en.wikipedia.org/wiki/Unified_Modeling_Language Unified Modeling Language (UML)] overview of the most important classes of the Part module:
This is a [http://en.wikipedia.org/wiki/Unified_Modeling_Language Unified Modeling Language (UML)] overview of the most important classes of the Part module:
[[Image:Part_Classes.jpg|center|Python classes of the Part module]]
[[Image:Part_Classes.jpg|center|Python classes of the Part module]]
Line 22: Line 24:


===Geometry=== <!--T:4-->
===Geometry=== <!--T:4-->

The geometric objects are the building blocks of all topological objects:
The geometric objects are the building blocks of all topological objects:
* '''Geom''' Base class of the geometric objects.
* '''Geom''' Base class of the geometric objects.
Line 31: Line 34:


===Topology=== <!--T:5-->
===Topology=== <!--T:5-->

The following topological data types are available:
The following topological data types are available:
* '''Compound''' A group of any type of topological objects.
* '''Compound''' A group of any type of topological objects.
Line 51: Line 55:
<!--T:8-->
<!--T:8-->
We will now create a topology by constructing it out of simpler geometry.
We will now create a topology by constructing it out of simpler geometry.
As a case study we use a part as seen in the picture which consists of
As a case study we will use a part as seen in the picture which consists of
four vertexes, two circles and two lines.
four vertices, two arcs and two lines.


[[#top|top]]
===Creating Geometry=== <!--T:9-->

First we have to create the distinct geometric parts of this wire.
===Creating geometry=== <!--T:9-->
And we have to take care that the vertexes of the geometric parts

are at the '''same''' position. Otherwise later on we might not be
able to connect the geometric parts to a topology!
First we create the distinct geometric parts of this wire. Making sure that parts that have to be connected later
share the same vertices.


<!--T:10-->
<!--T:10-->
So we create first the points:
So we create the points first:


</translate>
</translate>
{{Code|code=
{{Code|code=
import Part
from FreeCAD import Base
from FreeCAD import Base
V1 = Base.Vector(0,10,0)
V1 = Base.Vector(0, 10, 0)
V2 = Base.Vector(30,10,0)
V2 = Base.Vector(30, 10, 0)
V3 = Base.Vector(30,-10,0)
V3 = Base.Vector(30, -10, 0)
V4 = Base.Vector(0,-10,0)
V4 = Base.Vector(0, -10, 0)
}}
}}
<translate>
<translate>

[[#top|top]]


===Arc=== <!--T:11-->
===Arc=== <!--T:11-->
Line 80: Line 88:


<!--T:13-->
<!--T:13-->
To create an arc of circle we make a helper point and create the arc of
For each arc we need a helper point:
circle through three points:


</translate>
</translate>
{{Code|code=
{{Code|code=
VC1 = Base.Vector(-10,0,0)
VC1 = Base.Vector(-10, 0, 0)
C1 = Part.Arc(V1,VC1,V4)
C1 = Part.Arc(V1, VC1, V4)
VC2 = Base.Vector(40, 0, 0)
# and the second one
VC2 = Base.Vector(40,0,0)
C2 = Part.Arc(V2, VC2, V3)
C2 = Part.Arc(V2,VC2,V3)
}}
}}
<translate>
<translate>

[[#top|top]]


===Line=== <!--T:14-->
===Line=== <!--T:14-->
Line 100: Line 108:


<!--T:16-->
<!--T:16-->
The line segment can be created very simple out of the points:
The line segments can be created from two points:


</translate>
</translate>
{{Code|code=
{{Code|code=
L1 = Part.LineSegment(V1,V2)
L1 = Part.LineSegment(V1, V2)
L2 = Part.LineSegment(V3, V4)
# and the second one
L2 = Part.LineSegment(V3,V4)
}}
}}
<translate>
<translate>


[[#top|top]]
<!--T:110-->
''Note: in FreeCAD 0.16 Part.Line was used, for FreeCAD 0.17 Part.LineSegment has to be used''


===Putting it all together=== <!--T:17-->
===Putting it all together=== <!--T:17-->

The last step is to put the geometric base elements together
The last step is to put the geometric base elements together
and bake a topological shape:
and bake a topological shape:
Line 119: Line 126:
</translate>
</translate>
{{Code|code=
{{Code|code=
S1 = Part.Shape([C1,L1,C2,L2])
S1 = Part.Shape([C1, L1, C2, L2])
}}
}}
<translate>
<translate>

[[#top|top]]


===Make a prism=== <!--T:18-->
===Make a prism=== <!--T:18-->

Now extrude the wire in a direction and make an actual 3D shape:
Now extrude the wire in a direction and make an actual 3D shape:


Line 129: Line 139:
{{Code|code=
{{Code|code=
W = Part.Wire(S1.Edges)
W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0,0,10))
P = W.extrude(Base.Vector(0, 0, 10))
}}
}}
<translate>
<translate>

[[#top|top]]


===Show it all=== <!--T:19-->
===Show it all=== <!--T:19-->
Line 144: Line 156:


==Creating basic shapes== <!--T:20-->
==Creating basic shapes== <!--T:20-->

You can easily create basic topological objects with the "make...()"
You can easily create basic topological objects with the {{incode|make...()}}
methods from the Part Module:
methods from the Part Module:


</translate>
</translate>
{{Code|code=
{{Code|code=
b = Part.makeBox(100,100,100)
b = Part.makeBox(100, 100, 100)
Part.show(b)
Part.show(b)
}}
}}
Line 155: Line 168:


<!--T:21-->
<!--T:21-->
Other make...() methods available:
Some available {{incode|make...()}} methods:
* '''makeBox(l,w,h)''': Makes a box located in p and pointing into the direction d with the dimensions (l,w,h)
* {{incode|makeBox(l, w, h)}} Makes a box located in p and pointing into the direction d with the dimensions (l,w,h).
* '''makeCircle(radius)''': Makes a circle with a given radius
* {{incode|makeCircle(radius)}} Makes a circle with a given radius.
* '''makeCone(radius1,radius2,height)''': Makes a cone with the given radii and height
* {{incode|makeCone(radius1, radius2, height)}} Makes a cone with the given radii and height.
* '''makeCylinder(radius,height)''': Makes a cylinder with a given radius and height.
* {{incode|makeCylinder(radius, height)}} Makes a cylinder with a given radius and height.
* '''makeLine((x1,y1,z1),(x2,y2,z2))''': Makes a line from two points
* {{incode|makeLine((x1, y1, z1), (x2, y2, z2))}} Makes a line from two points.
* '''makePlane(length,width)''': Makes a plane with length and width
* {{incode|makePlane(length, width)}} Makes a plane with length and width.
* '''makePolygon(list)''': Makes a polygon from a list of points
* {{incode|makePolygon(list)}} Makes a polygon from a list of points.
* '''makeSphere(radius)''': Makes a sphere with a given radius
* {{incode|makeSphere(radius)}} Makes a sphere with a given radius.
* '''makeTorus(radius1,radius2)''': Makes a torus with the given radii
* {{incode|makeTorus(radius1, radius2)}} Makes a torus with the given radii.
See the [[Part API]] page for a complete list of available methods of the Part module.
See the [[Part_API|Part API]] page for a complete list of available methods of the Part module.

[[#top|top]]


===Importing the needed modules=== <!--T:22-->
===Importing the needed modules=== <!--T:22-->

First we need to import the Part module so we can use its contents in Python.
First we need to import the Part module so we can use its contents in Python.
We'll also import the Base module from inside the FreeCAD module:
We'll also import the Base module from inside the FreeCAD module:
Line 178: Line 194:
<translate>
<translate>


[[#top|top]]
===Creating a Vector=== <!--T:23-->

===Creating a vector=== <!--T:23-->

[http://en.wikipedia.org/wiki/Euclidean_vector Vectors] are one of the most
[http://en.wikipedia.org/wiki/Euclidean_vector Vectors] are one of the most
important pieces of information when building shapes. They usually contain three numbers
important pieces of information when building shapes. They usually contain three numbers
(but not necessarily always): the x, y and z cartesian coordinates. You
(but not necessarily always): the X, Y and Z cartesian coordinates. You
create a vector like this:
create a vector like this:


</translate>
</translate>
{{Code|code=
{{Code|code=
myVector = Base.Vector(3,2,0)
myVector = Base.Vector(3, 2, 0)
}}
}}
<translate>
<translate>


<!--T:24-->
<!--T:24-->
We just created a vector at coordinates x=3, y=2, z=0. In the Part module,
We just created a vector at coordinates X = 3, Y = 2, Z = 0. In the Part module,
vectors are used everywhere. Part shapes also use another kind of point
vectors are used everywhere. Part shapes also use another kind of point
representation called Vertex which is simply a container
representation called Vertex which is simply a container
Line 204: Line 223:
<translate>
<translate>


[[#top|top]]
===Creating an Edge=== <!--T:25-->

An edge is nothing but a line with two vertexes:
===Creating an edge=== <!--T:25-->

An edge is nothing but a line with two vertices:


</translate>
</translate>
{{Code|code=
{{Code|code=
edge = Part.makeLine((0,0,0), (10,0,0))
edge = Part.makeLine((0, 0, 0), (10, 0, 0))
edge.Vertexes
edge.Vertexes
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]
Line 220: Line 242:
</translate>
</translate>
{{Code|code=
{{Code|code=
vec1 = Base.Vector(0,0,0)
vec1 = Base.Vector(0, 0, 0)
vec2 = Base.Vector(10,0,0)
vec2 = Base.Vector(10, 0, 0)
line = Part.LineSegment(vec1,vec2)
line = Part.LineSegment(vec1, vec2)
edge = line.toShape()
edge = line.toShape()
}}
}}
Line 238: Line 260:
}}
}}
<translate>
<translate>

[[#top|top]]


===Putting the shape on screen=== <!--T:28-->
===Putting the shape on screen=== <!--T:28-->

So far we created an edge object, but it doesn't appear anywhere on the screen.
So far we created an edge object, but it doesn't appear anywhere on the screen.
This is because the FreeCAD 3D scene
This is because the FreeCAD 3D scene
Line 253: Line 278:
<!--T:29-->
<!--T:29-->
The show function creates an object in our FreeCAD document and assigns our "edge" shape
The show function creates an object in our FreeCAD document and assigns our "edge" shape
to it. Use this whenever it is time to display your creation on screen.
to it. Use this whenever it is time to display your creation on screen.

[[#top|top]]

===Creating a wire=== <!--T:30-->


===Creating a Wire=== <!--T:30-->
A wire is a multi-edge line and can be created from a list of edges
A wire is a multi-edge line and can be created from a list of edges
or even a list of wires:
or even a list of wires:
Line 261: Line 289:
</translate>
</translate>
{{Code|code=
{{Code|code=
edge1 = Part.makeLine((0,0,0), (10,0,0))
edge1 = Part.makeLine((0, 0, 0), (10, 0, 0))
edge2 = Part.makeLine((10,0,0), (10,10,0))
edge2 = Part.makeLine((10, 0, 0), (10, 10, 0))
wire1 = Part.Wire([edge1,edge2])
wire1 = Part.Wire([edge1, edge2])
edge3 = Part.makeLine((10,10,0), (0,10,0))
edge3 = Part.makeLine((10, 10, 0), (0, 10, 0))
edge4 = Part.makeLine((0,10,0), (0,0,0))
edge4 = Part.makeLine((0, 10, 0), (0, 0, 0))
wire2 = Part.Wire([edge3,edge4])
wire2 = Part.Wire([edge3, edge4])
wire3 = Part.Wire([wire1,wire2])
wire3 = Part.Wire([wire1, wire2])
wire3.Edges
wire3.Edges
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
Line 275: Line 303:


<!--T:31-->
<!--T:31-->
Part.show(wire3) will display the 4 edges that compose our wire. Other
{{incode|Part.show(wire3)}} will display the 4 edges that compose our wire. Other
useful information can be easily retrieved:
useful information can be easily retrieved:


Line 291: Line 319:
<translate>
<translate>


[[#top|top]]
===Creating a Face=== <!--T:32-->

===Creating a face=== <!--T:32-->

Only faces created from closed wires will be valid. In this example, wire3
Only faces created from closed wires will be valid. In this example, wire3
is a closed wire but wire2 is not a closed wire (see above)
is a closed wire but wire2 is not (see above)


</translate>
</translate>
Line 299: Line 330:
face = Part.Face(wire3)
face = Part.Face(wire3)
face.Area
face.Area
> 99.999999999999972
> 99.99999999999999
face.CenterOfMass
face.CenterOfMass
> Vector (5, 5, 0)
> Vector (5, 5, 0)
Line 313: Line 344:


<!--T:33-->
<!--T:33-->
Only faces will have an area, not wires nor edges.
Only faces will have an area, wires and edges do not.


[[#top|top]]
===Creating a Circle=== <!--T:34-->

A circle can be created as simply as this:
===Creating a circle=== <!--T:34-->

A circle can be created like this:


</translate>
</translate>
Line 331: Line 365:
</translate>
</translate>
{{Code|code=
{{Code|code=
ccircle = Part.makeCircle(10, Base.Vector(10,0,0), Base.Vector(1,0,0))
ccircle = Part.makeCircle(10, Base.Vector(10, 0, 0), Base.Vector(1, 0, 0))
ccircle.Curve
ccircle.Curve
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))
Line 338: Line 372:


<!--T:36-->
<!--T:36-->
ccircle will be created at distance 10 from the x origin and will be facing
ccircle will be created at distance 10 from the X origin and will be facing
outwards along the x axis. Note: makeCircle only accepts Base.Vector() for the position
outwards along the X axis. Note: {{incode|makeCircle()}} only accepts {{incode|Base.Vector()}} for the position
and normal parameters, not tuples. You can also create part of the circle by giving
and normal parameters, not tuples. You can also create part of the circle by giving
a start and an end angle:
a start and an end angle:
Line 346: Line 380:
{{Code|code=
{{Code|code=
from math import pi
from math import pi
arc1 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 180)
arc1 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
arc2 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 180, 360)
arc2 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 180, 360)
}}
}}
<translate>
<translate>


<!--T:37-->
<!--T:37-->
Angles should be provided in degrees. If you have radians simply convert them using the formula:
Both arc1 and arc2 jointly will make a circle. Angles should be provided in
degrees; if you have radians simply convert them using the formula:
{{incode|degrees <nowiki>=</nowiki> radians * 180/pi}} or by using Python's {{incode|math}} module:
degrees = radians * 180/PI or using Python's math module (after doing import
math, of course):


</translate>
</translate>
{{Code|code=
{{Code|code=
import math
degrees = math.degrees(radians)
degrees = math.degrees(radians)
}}
}}
<translate>
<translate>


[[#top|top]]
===Creating an Arc along points=== <!--T:38-->

Unfortunately there is no makeArc function, but we have the Part.Arc function to
===Creating an arc along points=== <!--T:38-->

Unfortunately there is no {{incode|makeArc()}} function, but we have the {{incode|Part.Arc()}} function to
create an arc through three points. It creates an arc object
create an arc through three points. It creates an arc object
joining the start point to the end point through the middle point.
joining the start point to the end point through the middle point.
The arc object's .toShape() function must be called to get an edge object,
The arc object's {{incode|toShape()}} function must be called to get an edge object,
the same as when using Part.LineSegment instead of Part.makeLine.
the same as when using {{incode|Part.LineSegment}} instead of {{incode|Part.makeLine}}.


</translate>
</translate>
{{Code|code=
{{Code|code=
arc = Part.Arc(Base.Vector(0,0,0),Base.Vector(0,5,0),Base.Vector(5,5,0))
arc = Part.Arc(Base.Vector(0, 0, 0), Base.Vector(0, 5, 0), Base.Vector(5, 5, 0))
arc
arc
> <Arc object>
> <Arc object>
arc_edge = arc.toShape()
arc_edge = arc.toShape()
Part.show(arc_edge)
}}
}}
<translate>
<translate>


<!--T:39-->
<!--T:39-->
Arc only accepts Base.Vector() for points but not tuples. arc_edge is what
{{incode|Arc()}} only accepts {{incode|Base.Vector()}} for points and not tuples. You can also obtain
we want which we can display using Part.show(arc_edge). You can also obtain
an arc by using a portion of a circle:
an arc by using a portion of a circle:


Line 387: Line 423:
{{Code|code=
{{Code|code=
from math import pi
from math import pi
circle = Part.Circle(Base.Vector(0,0,0),Base.Vector(0,0,1),10)
circle = Part.Circle(Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 10)
arc = Part.Arc(circle,0,pi)
arc = Part.Arc(circle,0,pi)
}}
}}
Line 394: Line 430:
<!--T:40-->
<!--T:40-->
Arcs are valid edges like lines, so they can be used in wires also.
Arcs are valid edges like lines, so they can be used in wires also.

[[#top|top]]


===Creating a polygon=== <!--T:41-->
===Creating a polygon=== <!--T:41-->

A polygon is simply a wire with multiple straight edges. The makePolygon
A polygon is simply a wire with multiple straight edges. The {{incode|makePolygon()}}
function takes a list of points and creates a wire through those points:
function takes a list of points and creates a wire through those points:


</translate>
</translate>
{{Code|code=
{{Code|code=
lshape_wire = Part.makePolygon([Base.Vector(0,5,0),Base.Vector(0,0,0),Base.Vector(5,0,0)])
lshape_wire = Part.makePolygon([Base.Vector(0, 5, 0), Base.Vector(0, 0, 0), Base.Vector(5, 0, 0)])
}}
}}
<translate>
<translate>


[[#top|top]]
===Creating a Bézier curve=== <!--T:42-->

Bézier curves are used to model smooth curves using a series of poles (points) and optional weights. The function below makes a Part.BezierCurve from a series of FreeCAD.Vector points. (Note: when "getting" and "setting" a single pole or weight, indices start at 1, not 0.)
===Creating a bézier curve=== <!--T:42-->

Bézier curves are used to model smooth curves using a series of poles (points) and optional weights. The function below makes a {{incode|Part.BezierCurve()}} from a series of {{incode|FreeCAD.Vector()}} points. Note: when "getting" and "setting" a single pole or weight, indices start at 1, not 0.


</translate>
</translate>
Line 418: Line 460:
<translate>
<translate>


[[#top|top]]
===Creating a Plane=== <!--T:43-->

A Plane is simply a flat rectangular surface. The method used to create one is '''makePlane(length,width,[start_pnt,dir_normal])'''. By default
===Creating a plane=== <!--T:43-->
start_pnt = Vector(0,0,0) and dir_normal = Vector(0,0,1). Using dir_normal = Vector(0,0,1)

will create the plane facing in the positive z axis direction, while dir_normal = Vector(1,0,0) will create the
A Plane is a flat rectangular surface. The method used to create one is {{incode|makePlane(length, width, [start_pnt, dir_normal])}}. By default start_pnt = Vector(0, 0, 0) and dir_normal = Vector(0, 0, 1). Using dir_normal = Vector(0, 0, 1)
plane facing in the positive x axis direction:
will create the plane facing in the positive Z axis direction, while dir_normal = Vector(1, 0, 0) will create the
plane facing in the positive X axis direction:


</translate>
</translate>
{{Code|code=
{{Code|code=
plane = Part.makePlane(2,2)
plane = Part.makePlane(2, 2)
plane
plane
><Face object at 028AF990>
> <Face object at 028AF990>
plane = Part.makePlane(2, 2, Base.Vector(3,0,0), Base.Vector(0,1,0))
plane = Part.makePlane(2, 2, Base.Vector(3, 0, 0), Base.Vector(0, 1, 0))
plane.BoundBox
plane.BoundBox
> BoundBox (3, 0, 0, 5, 0, 2)
> BoundBox (3, 0, 0, 5, 0, 2)
Line 436: Line 480:


<!--T:44-->
<!--T:44-->
BoundBox is a cuboid enclosing the plane with a diagonal starting at
{{incode|BoundBox}} is a cuboid enclosing the plane with a diagonal starting at
(3,0,0) and ending at (5,0,2). Here the BoundBox thickness along the y axis is zero,
(3, 0, 0) and ending at (5, 0, 2). Here the {{incode|BoundBox}} thickness along the Y axis is zero,
since our shape is totally flat.
since our shape is totally flat.


<!--T:45-->
<!--T:45-->
Note: makePlane only accepts Base.Vector() for start_pnt and dir_normal but not tuples.
Note: {{incode|makePlane()}} only accepts {{incode|Base.Vector()}} for start_pnt and dir_normal and not tuples.

[[#top|top]]


===Creating an ellipse=== <!--T:46-->
===Creating an ellipse=== <!--T:46-->

There are several ways to create an ellipse:
There are several ways to create an ellipse:


Line 453: Line 500:


<!--T:47-->
<!--T:47-->
Creates an ellipse with major radius 2 and minor radius 1 with the center at (0,0,0).
Creates an ellipse with major radius 2 and minor radius 1 with the center at (0, 0, 0).


</translate>
</translate>
Line 466: Line 513:
</translate>
</translate>
{{Code|code=
{{Code|code=
Part.Ellipse(S1,S2,Center)
Part.Ellipse(S1, S2, Center)
}}
}}
<translate>
<translate>
Line 478: Line 525:
</translate>
</translate>
{{Code|code=
{{Code|code=
Part.Ellipse(Center,MajorRadius,MinorRadius)
Part.Ellipse(Center, MajorRadius, MinorRadius)
}}
}}
<translate>
<translate>
Line 484: Line 531:
<!--T:50-->
<!--T:50-->
Creates an ellipse with major and minor radii MajorRadius and MinorRadius,
Creates an ellipse with major and minor radii MajorRadius and MinorRadius,
located in the plane defined by Center and the normal (0,0,1)
located in the plane defined by Center and the normal (0, 0, 1)


</translate>
</translate>
{{Code|code=
{{Code|code=
eli = Part.Ellipse(Base.Vector(10,0,0),Base.Vector(0,5,0),Base.Vector(0,0,0))
eli = Part.Ellipse(Base.Vector(10, 0, 0), Base.Vector(0, 5, 0), Base.Vector(0, 0, 0))
Part.show(eli.toShape())
Part.show(eli.toShape())
}}
}}
Line 494: Line 541:


<!--T:51-->
<!--T:51-->
In the above code we have passed S1, S2 and center. Similar to Arc,
In the above code we have passed S1, S2 and center. Similar to {{incode|Arc}},
Ellipse creates an ellipse object but not edge, so we need to
{{incode|Ellipse}} creates an ellipse object not an edge, so we need to
convert it into an edge using toShape() for display.
convert it into an edge using {{incode|toShape()}} for display.


<!--T:52-->
<!--T:52-->
Note: Arc only accepts Base.Vector() for points but not tuples.
Note: {{incode|Ellipse()}} only accepts {{incode|Base.Vector()}} for points and not tuples.


</translate>
</translate>
{{Code|code=
{{Code|code=
eli = Part.Ellipse(Base.Vector(0,0,0),10,5)
eli = Part.Ellipse(Base.Vector(0, 0, 0), 10, 5)
Part.show(eli.toShape())
Part.show(eli.toShape())
}}
}}
Line 509: Line 556:


<!--T:53-->
<!--T:53-->
for the above Ellipse constructor we have passed center, MajorRadius and MinorRadius.
For the above Ellipse constructor we have passed center, MajorRadius and MinorRadius.


[[#top|top]]
===Creating a Torus=== <!--T:54-->

Using '''makeTorus(radius1,radius2,[pnt,dir,angle1,angle2,angle])'''.
===Creating a torus=== <!--T:54-->
By default pnt=Vector(0,0,0), dir=Vector(0,0,1), angle1=0, angle2=360 and angle=360.

Using {{incode|makeTorus(radius1, radius2, [pnt, dir, angle1, angle2, angle])}}.
By default pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1), angle1 = 0, angle2 = 360 and angle = 360.
Consider a torus as small circle sweeping along a big circle. Radius1 is the
Consider a torus as small circle sweeping along a big circle. Radius1 is the
radius of the big cirlce, radius2 is the radius of the small circle, pnt is the center
radius of the big circle, radius2 is the radius of the small circle, pnt is the center
of the torus and dir is the normal direction. angle1 and angle2 are angles in
of the torus and dir is the normal direction. angle1 and angle2 are angles in
radians for the small circle; the last parameter angle is to make a section of
degrees for the small circle; the last angle parameter is to make a section of
the torus:
the torus:


Line 532: Line 582:
</translate>
</translate>
{{Code|code=
{{Code|code=
tor=Part.makeTorus(10, 5, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 180)
tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
}}
}}
<translate>
<translate>
Line 541: Line 591:
</translate>
</translate>
{{Code|code=
{{Code|code=
tor=Part.makeTorus(10, 5, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, 360, 180)
tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 360, 180)
}}
}}
<translate>
<translate>
Line 547: Line 597:
<!--T:57-->
<!--T:57-->
The above code will create a semi torus; only the last parameter is changed.
The above code will create a semi torus; only the last parameter is changed.
i.e the angle and remaining angles are defaults. Giving the angle 180 will
i.e the remaining angles are defaults. Giving the angle 180 will
create the torus from 0 to 180, that is, a half torus.
create the torus from 0 to 180, that is, a half torus.

[[#top|top]]


===Creating a box or cuboid=== <!--T:58-->
===Creating a box or cuboid=== <!--T:58-->

Using '''makeBox(length,width,height,[pnt,dir])'''.
Using {{incode|makeBox(length, width, height, [pnt, dir])}}.
By default pnt=Vector(0,0,0) and dir=Vector(0,0,1).
By default pnt = Vector(0, 0, 0) and dir = Vector(0, 0, 1).


</translate>
</translate>
{{Code|code=
{{Code|code=
box = Part.makeBox(10,10,10)
box = Part.makeBox(10, 10, 10)
len(box.Vertexes)
len(box.Vertexes)
> 8
> 8
Line 562: Line 615:
<translate>
<translate>


[[#top|top]]
===Creating a Sphere=== <!--T:59-->

Using '''makeSphere(radius,[pnt, dir, angle1,angle2,angle3])'''. By default
===Creating a sphere=== <!--T:59-->
pnt=Vector(0,0,0), dir=Vector(0,0,1), angle1=-90, angle2=90 and angle3=360.

Using {{incode|makeSphere(radius, [pnt, dir, angle1, angle2, angle3])}}. By default
pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1), angle1 = -90, angle2 = 90 and angle3 = 360.
angle1 and angle2 are the vertical minimum and maximum of the sphere, angle3
angle1 and angle2 are the vertical minimum and maximum of the sphere, angle3
is the sphere diameter.
is the sphere diameter.
Line 571: Line 627:
{{Code|code=
{{Code|code=
sphere = Part.makeSphere(10)
sphere = Part.makeSphere(10)
hemisphere = Part.makeSphere(10,Base.Vector(0,0,0),Base.Vector(0,0,1),-90,90,180)
hemisphere = Part.makeSphere(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), -90, 90, 180)
}}
}}
<translate>
<translate>


[[#top|top]]
===Creating a Cylinder=== <!--T:60-->

Using '''makeCylinder(radius,height,[pnt,dir,angle])'''. By default
===Creating a cylinder=== <!--T:60-->
pnt=Vector(0,0,0),dir=Vector(0,0,1) and angle=360.

Using {{incode|makeCylinder(radius, height, [pnt, dir, angle])}}. By default
pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1) and angle = 360.


</translate>{{Code|code=
</translate>{{Code|code=
cylinder = Part.makeCylinder(5,20)
cylinder = Part.makeCylinder(5, 20)
partCylinder = Part.makeCylinder(5,20,Base.Vector(20,0,0),Base.Vector(0,0,1),180)
partCylinder = Part.makeCylinder(5, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)
}}<translate>
}}<translate>


[[#top|top]]
===Creating a Cone=== <!--T:61-->

Using '''makeCone(radius1,radius2,height,[pnt,dir,angle])'''. By default
===Creating a cone=== <!--T:61-->
pnt=Vector(0,0,0), dir=Vector(0,0,1) and angle=360.

Using {{incode|makeCone(radius1, radius2, height, [pnt, dir, angle])}}. By default
pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1) and angle = 360.


</translate>{{Code|code=
</translate>{{Code|code=
cone = Part.makeCone(10,0,20)
cone = Part.makeCone(10, 0, 20)
semicone = Part.makeCone(10,0,20,Base.Vector(20,0,0),Base.Vector(0,0,1),180)
semicone = Part.makeCone(10, 0, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)
}}<translate>
}}<translate>


Line 596: Line 658:


==Modifying shapes== <!--T:62-->
==Modifying shapes== <!--T:62-->

There are several ways to modify shapes. Some are simple transformation operations
There are several ways to modify shapes. Some are simple transformation operations
such as moving or rotating shapes, others are more complex, such as unioning and
such as moving or rotating shapes, others are more complex, such as unioning and
Line 605: Line 668:


===Translating a shape=== <!--T:64-->
===Translating a shape=== <!--T:64-->

Translating is the act of moving a shape from one place to another.
Translating is the act of moving a shape from one place to another.
Any shape (edge, face, cube, etc...) can be translated the same way:
Any shape (edge, face, cube, etc...) can be translated the same way:


</translate>{{Code|code=
</translate>{{Code|code=
myShape = Part.makeBox(2,2,2)
myShape = Part.makeBox(2, 2, 2)
myShape.translate(Base.Vector(2,0,0))
myShape.translate(Base.Vector(2, 0, 0))
}}<translate>
}}<translate>


<!--T:65-->
<!--T:65-->
This will move our shape "myShape" 2 units in the x direction.
This will move our shape "myShape" 2 units in the X direction.

[[#top|top]]


===Rotating a shape=== <!--T:66-->
===Rotating a shape=== <!--T:66-->

To rotate a shape, you need to specify the rotation center, the axis,
To rotate a shape, you need to specify the rotation center, the axis,
and the rotation angle:
and the rotation angle:


</translate>{{Code|code=
</translate>{{Code|code=
myShape.rotate(Vector(0,0,0),Vector(0,0,1),180)
myShape.rotate(Base.Vector(0, 0, 0),Base.Vector(0, 0, 1), 180)
}}<translate>
}}<translate>


Line 627: Line 694:
The above code will rotate the shape 180 degrees around the Z Axis.
The above code will rotate the shape 180 degrees around the Z Axis.


[[#top|top]]
===Generic transformations with matrixes=== <!--T:68-->

===Generic transformations with matrices=== <!--T:68-->

A matrix is a very convenient way to store transformations in the 3D
A matrix is a very convenient way to store transformations in the 3D
world. In a single matrix, you can set translation, rotation and scaling
world. In a single matrix, you can set translation, rotation and scaling
Line 634: Line 704:
</translate>{{Code|code=
</translate>{{Code|code=
myMat = Base.Matrix()
myMat = Base.Matrix()
myMat.move(Base.Vector(2,0,0))
myMat.move(Base.Vector(2, 0, 0))
myMat.rotateZ(math.pi/2)
myMat.rotateZ(math.pi/2)
}}<translate>
}}<translate>
Line 643: Line 713:


</translate>{{Code|code=
</translate>{{Code|code=
myMat.move(2,0,0)
myMat.move(2, 0, 0)
myMat.move(Base.Vector(2,0,0))
myMat.move(Base.Vector(2, 0, 0))
}}<translate>
}}<translate>


<!--T:70-->
<!--T:70-->
Once our matrix is set, we can apply it to our shape. FreeCAD provides two
Once our matrix is set, we can apply it to our shape. FreeCAD provides two
methods for doing that: transformShape() and transformGeometry(). The difference
methods for doing that: {{incode|transformShape()}} and {{incode|transformGeometry()}}. The difference
is that with the first one, you are sure that no deformations will occur (see
is that with the first one, you are sure that no deformations will occur (see
"scaling a shape" below). We can apply our transformation like this:
[[#Scaling a shape|Scaling a shape]] below). We can apply our transformation like this:


</translate>{{Code|code=
</translate>{{Code|code=
Line 663: Line 733:
myShape.transformGeometry(myMat)
myShape.transformGeometry(myMat)
}}<translate>
}}<translate>

[[#top|top]]


===Scaling a shape=== <!--T:72-->
===Scaling a shape=== <!--T:72-->

Scaling a shape is a more dangerous operation because, unlike translation
Scaling a shape is a more dangerous operation because, unlike translation
or rotation, scaling non-uniformly (with different values for x, y and z)
or rotation, scaling non-uniformly (with different values for X, Y and Z)
can modify the structure of the shape. For example, scaling a circle with
can modify the structure of the shape. For example, scaling a circle with
a higher value horizontally than vertically will transform it into an
a higher value horizontally than vertically will transform it into an
ellipse, which behaves mathematically very differently. For scaling, we
ellipse, which behaves mathematically very differently. For scaling, we
can't use the transformShape, we must use transformGeometry():
cannot use the {{incode|transformShape()}}, we must use {{incode|transformGeometry()}}:


</translate>{{Code|code=
</translate>{{Code|code=
myMat = Base.Matrix()
myMat = Base.Matrix()
myMat.scale(2,1,1)
myMat.scale(2, 1, 1)
myShape=myShape.transformGeometry(myMat)
myShape=myShape.transformGeometry(myMat)
}}<translate>
}}<translate>
Line 680: Line 753:
[[#top|top]]
[[#top|top]]


==Boolean Operations== <!--T:73-->
==Boolean operations== <!--T:73-->


===Subtraction=== <!--T:74-->
===Subtraction=== <!--T:74-->

Subtracting a shape from another one is called "cut" in OCC/FreeCAD jargon
Subtracting a shape from another one is called {{incode|cut}} in FreeCAD
and is done like this:
and is done like this:


</translate>{{Code|code=
</translate>{{Code|code=
cylinder = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
sphere = Part.makeSphere(5,Base.Vector(5,0,0))
sphere = Part.makeSphere(5, Base.Vector(5, 0, 0))
diff = cylinder.cut(sphere)
diff = cylinder.cut(sphere)
}}<translate>
}}<translate>

[[#top|top]]


===Intersection=== <!--T:75-->
===Intersection=== <!--T:75-->

The same way, the intersection between two shapes is called "common" and is done
The same way, the intersection between two shapes is called {{incode|common}} and is done
this way:
this way:


</translate>{{Code|code=
</translate>{{Code|code=
cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
common = cylinder1.common(cylinder2)
common = cylinder1.common(cylinder2)
}}<translate>
}}<translate>

[[#top|top]]


===Union=== <!--T:76-->
===Union=== <!--T:76-->

Union is called "fuse" and works the same way:
Union is called {{incode|fuse}} and works the same way:


</translate>{{Code|code=
</translate>{{Code|code=
cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
fuse = cylinder1.fuse(cylinder2)
fuse = cylinder1.fuse(cylinder2)
}}<translate>
}}<translate>

[[#top|top]]


===Section=== <!--T:77-->
===Section=== <!--T:77-->

A Section is the intersection between a solid shape and a plane shape.
A {{incode|section}} is the intersection between a solid shape and a plane shape.
It will return an intersection curve, a compound curve composed of edges.
It will return an intersection curve, a compound curve composed of edges.


</translate>{{Code|code=
</translate>{{Code|code=
cylinder1 = Part.makeCylinder(3,10,Base.Vector(0,0,0),Base.Vector(1,0,0))
cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3,10,Base.Vector(5,0,-5),Base.Vector(0,0,1))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
section = cylinder1.section(cylinder2)
section = cylinder1.section(cylinder2)
section.Wires
section.Wires
Line 726: Line 809:
<Edge object at 0D8F4BB0>]
<Edge object at 0D8F4BB0>]
}}<translate>
}}<translate>

[[#top|top]]


===Extrusion=== <!--T:78-->
===Extrusion=== <!--T:78-->

Extrusion is the act of "pushing" a flat shape in a certain direction, resulting in
Extrusion is the act of "pushing" a flat shape in a certain direction, resulting in
a solid body. Think of a circle becoming a tube by "pushing it out":
a solid body. Think of a circle becoming a tube by "pushing it out":
Line 733: Line 819:
</translate>{{Code|code=
</translate>{{Code|code=
circle = Part.makeCircle(10)
circle = Part.makeCircle(10)
tube = circle.extrude(Base.Vector(0,0,2))
tube = circle.extrude(Base.Vector(0, 0, 2))
}}<translate>
}}<translate>


Line 743: Line 829:
wire = Part.Wire(circle)
wire = Part.Wire(circle)
disc = Part.Face(wire)
disc = Part.Face(wire)
cylinder = disc.extrude(Base.Vector(0,0,2))
cylinder = disc.extrude(Base.Vector(0, 0, 2))
}}<translate>
}}<translate>


Line 749: Line 835:


==Exploring shapes== <!--T:80-->
==Exploring shapes== <!--T:80-->

You can easily explore the topological data structure:
You can easily explore the topological data structure:


</translate>{{Code|code=
</translate>{{Code|code=
import Part
import Part
b = Part.makeBox(100,100,100)
b = Part.makeBox(100, 100, 100)
b.Wires
b.Wires
w = b.Wires[0]
w = b.Wires[0]
Line 769: Line 856:
<!--T:81-->
<!--T:81-->
By typing the lines above in the Python interpreter, you will gain a good
By typing the lines above in the Python interpreter, you will gain a good
understanding of the structure of Part objects. Here, our makeBox() command
understanding of the structure of Part objects. Here, our {{incode|makeBox()}} command
created a solid shape. This solid, like all Part solids, contains faces.
created a solid shape. This solid, like all Part solids, contains faces.
Faces always contain wires, which are lists of edges that border the face.
Faces always contain wires, which are lists of edges that border the face.
Each face has at least one closed wire (it can have more if the face has a hole).
Each face has at least one closed wire (it can have more if the face has a hole).
In the wire, we can look at each edge separately, and inside each edge, we can
In the wire, we can look at each edge separately, and inside each edge, we can
see the vertexes. Straight edges have only two vertexes, obviously.
see the vertices. Straight edges have only two vertices, obviously.


[[#top|top]]
[[#top|top]]


===Edge analysis=== <!--T:82-->
===Edge analysis=== <!--T:82-->

In case of an edge, which is an arbitrary curve, it's most likely you want to
In case of an edge, which is an arbitrary curve, it's most likely you want to
do a discretization. In FreeCAD the edges are parametrized by their lengths.
do a discretization. In FreeCAD the edges are parametrized by their lengths.
Line 785: Line 873:
</translate>{{Code|code=
</translate>{{Code|code=
import Part
import Part
box = Part.makeBox(100,100,100)
box = Part.makeBox(100, 100, 100)
anEdge = box.Edges[0]
anEdge = box.Edges[0]
print anEdge.Length
print(anEdge.Length)
}}<translate>
}}<translate>


Line 796: Line 884:


</translate>{{Code|code=
</translate>{{Code|code=
anEdge.tangentAt(0.0) # tangent direction at the beginning
anEdge.tangentAt(0.0) # tangent direction at the beginning
anEdge.valueAt(0.0) # Point at the beginning
anEdge.valueAt(0.0) # Point at the beginning
anEdge.valueAt(100.0) # Point at the end of the edge
anEdge.valueAt(100.0) # Point at the end of the edge
anEdge.derivative1At(50.0) # first derivative of the curve in the middle
anEdge.derivative1At(50.0) # first derivative of the curve in the middle
anEdge.derivative2At(50.0) # second derivative of the curve in the middle
anEdge.derivative2At(50.0) # second derivative of the curve in the middle
anEdge.derivative3At(50.0) # third derivative of the curve in the middle
anEdge.derivative3At(50.0) # third derivative of the curve in the middle
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.curvatureAt(50.0) # the curvature
anEdge.curvatureAt(50.0) # the curvature
anEdge.normalAt(50) # normal vector at that position (if defined)
anEdge.normalAt(50) # normal vector at that position (if defined)
}}<translate>
}}<translate>


Line 810: Line 898:


===Using the selection=== <!--T:84-->
===Using the selection=== <!--T:84-->

Here we see now how we can use the selection the user did in the viewer.
Here we see now how we can use the selection the user did in the viewer.
First of all we create a box and show it in the viewer.
First of all we create a box and show it in the viewer.
Line 815: Line 904:
</translate>{{Code|code=
</translate>{{Code|code=
import Part
import Part
Part.show(Part.makeBox(100,100,100))
Part.show(Part.makeBox(100, 100, 100))
Gui.SendMsgToActiveView("ViewFit")
Gui.SendMsgToActiveView("ViewFit")
}}<translate>
}}<translate>
Line 825: Line 914:
</translate>{{Code|code=
</translate>{{Code|code=
for o in Gui.Selection.getSelectionEx():
for o in Gui.Selection.getSelectionEx():
print o.ObjectName
print(o.ObjectName)
for s in o.SubElementNames:
for s in o.SubElementNames:
print "name: ",s
print("name: ", s)
for s in o.SubObjects:
for s in o.SubObjects:
print "object: ",s
print("object: ", s)
}}<translate>
}}<translate>


Line 838: Line 927:
length = 0.0
length = 0.0
for o in Gui.Selection.getSelectionEx():
for o in Gui.Selection.getSelectionEx():
for s in o.SubObjects:
for s in o.SubObjects:
length += s.Length
length += s.Length

print "Length of the selected edges:" ,length
print("Length of the selected edges: ", length)
}}<translate>
}}<translate>


Line 846: Line 936:


==Complete example: The OCC bottle== <!--T:87-->
==Complete example: The OCC bottle== <!--T:87-->

A typical example found in the
A typical example found in the
[http://www.opencascade.com/doc/occt-6.9.0/overview/html/occt__tutorial.html#sec1 OpenCasCade Technology Tutorial]
[http://www.opencascade.com/doc/occt-6.9.0/overview/html/occt__tutorial.html#sec1 OpenCasCade Technology Tutorial]
Line 864: Line 955:


===The complete script=== <!--T:88-->
===The complete script=== <!--T:88-->

Here is the complete MakeBottle script:
Here is the complete MakeBottle script:


Line 1,059: Line 1,151:


==Box pierced== <!--T:100-->
==Box pierced== <!--T:100-->

Here is a complete example of building a pierced box.
Here is a complete example of building a pierced box.


Line 1,115: Line 1,208:
[[#top|top]]
[[#top|top]]


==Loading and Saving== <!--T:102-->
==Loading and saving== <!--T:102-->

There are several ways to save your work in the Part module. You can
There are several ways to save your work in the Part module. You can
of course save your FreeCAD document, but you can also save Part
of course save your FreeCAD document, but you can also save Part

Revision as of 20:31, 26 May 2020

Introduction

Here we will explain to you how to control the Part Module directly from the FreeCAD Python interpreter, or from any external script. The basics about Topological data scripting are described in Part Module Explaining the concepts. Be sure to browse the Scripting section and the FreeCAD_Scripting_Basics pages if you need more information about how Python scripting works in FreeCAD. If you are new to Python, it is a good idea to first read the Introduction to Python.

Class diagram

This is a Unified Modeling Language (UML) overview of the most important classes of the Part module:

Python classes of the Part module
Python classes of the Part module

top

Geometry

The geometric objects are the building blocks of all topological objects:

  • Geom Base class of the geometric objects.
  • Line A straight line in 3D, defined by starting point and end point.
  • Circle Circle or circle segment defined by a center point and start and end point.
  • ...... Etc.

top

Topology

The following topological data types are available:

  • Compound A group of any type of topological objects.
  • Compsolid A composite solid is a set of solids connected by their faces. It expands the notions of WIRE and SHELL to solids.
  • Solid A part of space limited by shells. It is three dimensional.
  • Shell A set of faces connected by their edges. A shell can be open or closed.
  • Face In 2D it is part of a plane; in 3D it is part of a surface. Its geometry is constrained (trimmed) by contours. It is two dimensional.
  • Wire A set of edges connected by their vertices. It can be an open or closed contour depending on whether the edges are linked or not.
  • Edge A topological element corresponding to a restrained curve. An edge is generally limited by vertices. It has one dimension.
  • Vertex A topological element corresponding to a point. It has zero dimension.
  • Shape A generic term covering all of the above.

top

Quick example : Creating simple topology

Wire

We will now create a topology by constructing it out of simpler geometry. As a case study we will use a part as seen in the picture which consists of four vertices, two arcs and two lines.

top

Creating geometry

First we create the distinct geometric parts of this wire. Making sure that parts that have to be connected later share the same vertices.

So we create the points first:

import Part
from FreeCAD import Base
V1 = Base.Vector(0, 10, 0)
V2 = Base.Vector(30, 10, 0)
V3 = Base.Vector(30, -10, 0)
V4 = Base.Vector(0, -10, 0)

top

Arc

Circle


For each arc we need a helper point:

VC1 = Base.Vector(-10, 0, 0)
C1 = Part.Arc(V1, VC1, V4)
VC2 = Base.Vector(40, 0, 0)
C2 = Part.Arc(V2, VC2, V3)

top

Line

Line


The line segments can be created from two points:

L1 = Part.LineSegment(V1, V2)
L2 = Part.LineSegment(V3, V4)

top

Putting it all together

The last step is to put the geometric base elements together and bake a topological shape:

S1 = Part.Shape([C1, L1, C2, L2])

top

Make a prism

Now extrude the wire in a direction and make an actual 3D shape:

W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0, 0, 10))

top

Show it all

Part.show(P)

top

Creating basic shapes

You can easily create basic topological objects with the make...() methods from the Part Module:

b = Part.makeBox(100, 100, 100)
Part.show(b)

Some available make...() methods:

  • makeBox(l, w, h) Makes a box located in p and pointing into the direction d with the dimensions (l,w,h).
  • makeCircle(radius) Makes a circle with a given radius.
  • makeCone(radius1, radius2, height) Makes a cone with the given radii and height.
  • makeCylinder(radius, height) Makes a cylinder with a given radius and height.
  • makeLine((x1, y1, z1), (x2, y2, z2)) Makes a line from two points.
  • makePlane(length, width) Makes a plane with length and width.
  • makePolygon(list) Makes a polygon from a list of points.
  • makeSphere(radius) Makes a sphere with a given radius.
  • makeTorus(radius1, radius2) Makes a torus with the given radii.

See the Part API page for a complete list of available methods of the Part module.

top

Importing the needed modules

First we need to import the Part module so we can use its contents in Python. We'll also import the Base module from inside the FreeCAD module:

import Part
from FreeCAD import Base

top

Creating a vector

Vectors are one of the most important pieces of information when building shapes. They usually contain three numbers (but not necessarily always): the X, Y and Z cartesian coordinates. You create a vector like this:

myVector = Base.Vector(3, 2, 0)

We just created a vector at coordinates X = 3, Y = 2, Z = 0. In the Part module, vectors are used everywhere. Part shapes also use another kind of point representation called Vertex which is simply a container for a vector. You access the vector of a vertex like this:

myVertex = myShape.Vertexes[0]
print myVertex.Point
> Vector (3, 2, 0)

top

Creating an edge

An edge is nothing but a line with two vertices:

edge = Part.makeLine((0, 0, 0), (10, 0, 0))
edge.Vertexes
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]

Note: You can also create an edge by passing two vectors:

vec1 = Base.Vector(0, 0, 0)
vec2 = Base.Vector(10, 0, 0)
line = Part.LineSegment(vec1, vec2)
edge = line.toShape()

You can find the length and center of an edge like this:

edge.Length
> 10.0
edge.CenterOfMass
> Vector (5, 0, 0)

top

Putting the shape on screen

So far we created an edge object, but it doesn't appear anywhere on the screen. This is because the FreeCAD 3D scene only displays what you tell it to display. To do that, we use this simple method:

Part.show(edge)

The show function creates an object in our FreeCAD document and assigns our "edge" shape to it. Use this whenever it is time to display your creation on screen.

top

Creating a wire

A wire is a multi-edge line and can be created from a list of edges or even a list of wires:

edge1 = Part.makeLine((0, 0, 0), (10, 0, 0))
edge2 = Part.makeLine((10, 0, 0), (10, 10, 0))
wire1 = Part.Wire([edge1, edge2]) 
edge3 = Part.makeLine((10, 10, 0), (0, 10, 0))
edge4 = Part.makeLine((0, 10, 0), (0, 0, 0))
wire2 = Part.Wire([edge3, edge4])
wire3 = Part.Wire([wire1, wire2])
wire3.Edges
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
Part.show(wire3)

Part.show(wire3) will display the 4 edges that compose our wire. Other useful information can be easily retrieved:

wire3.Length
> 40.0
wire3.CenterOfMass
> Vector (5, 5, 0)
wire3.isClosed()
> True
wire2.isClosed()
> False

top

Creating a face

Only faces created from closed wires will be valid. In this example, wire3 is a closed wire but wire2 is not (see above)

face = Part.Face(wire3)
face.Area
> 99.99999999999999
face.CenterOfMass
> Vector (5, 5, 0)
face.Length
> 40.0
face.isValid()
> True
sface = Part.Face(wire2)
face.isValid()
> False

Only faces will have an area, wires and edges do not.

top

Creating a circle

A circle can be created like this:

circle = Part.makeCircle(10)
circle.Curve
> Circle (Radius : 10, Position : (0, 0, 0), Direction : (0, 0, 1))

If you want to create it at a certain position and with a certain direction:

ccircle = Part.makeCircle(10, Base.Vector(10, 0, 0), Base.Vector(1, 0, 0))
ccircle.Curve
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))

ccircle will be created at distance 10 from the X origin and will be facing outwards along the X axis. Note: makeCircle() only accepts Base.Vector() for the position and normal parameters, not tuples. You can also create part of the circle by giving a start and an end angle:

from math import pi
arc1 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
arc2 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 180, 360)

Angles should be provided in degrees. If you have radians simply convert them using the formula: degrees = radians * 180/pi or by using Python's math module:

import math
degrees = math.degrees(radians)

top

Creating an arc along points

Unfortunately there is no makeArc() function, but we have the Part.Arc() function to create an arc through three points. It creates an arc object joining the start point to the end point through the middle point. The arc object's toShape() function must be called to get an edge object, the same as when using Part.LineSegment instead of Part.makeLine.

arc = Part.Arc(Base.Vector(0, 0, 0), Base.Vector(0, 5, 0), Base.Vector(5, 5, 0))
arc
> <Arc object>
arc_edge = arc.toShape()
Part.show(arc_edge)

Arc() only accepts Base.Vector() for points and not tuples. You can also obtain an arc by using a portion of a circle:

from math import pi
circle = Part.Circle(Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 10)
arc = Part.Arc(circle,0,pi)

Arcs are valid edges like lines, so they can be used in wires also.

top

Creating a polygon

A polygon is simply a wire with multiple straight edges. The makePolygon() function takes a list of points and creates a wire through those points:

lshape_wire = Part.makePolygon([Base.Vector(0, 5, 0), Base.Vector(0, 0, 0), Base.Vector(5, 0, 0)])

top

Creating a bézier curve

Bézier curves are used to model smooth curves using a series of poles (points) and optional weights. The function below makes a Part.BezierCurve() from a series of FreeCAD.Vector() points. Note: when "getting" and "setting" a single pole or weight, indices start at 1, not 0.

def makeBCurveEdge(Points):
   geomCurve = Part.BezierCurve()
   geomCurve.setPoles(Points)
   edge = Part.Edge(geomCurve)
   return(edge)

top

Creating a plane

A Plane is a flat rectangular surface. The method used to create one is makePlane(length, width, [start_pnt, dir_normal]). By default start_pnt = Vector(0, 0, 0) and dir_normal = Vector(0, 0, 1). Using dir_normal = Vector(0, 0, 1) will create the plane facing in the positive Z axis direction, while dir_normal = Vector(1, 0, 0) will create the plane facing in the positive X axis direction:

plane = Part.makePlane(2, 2)
plane
> <Face object at 028AF990>
plane = Part.makePlane(2, 2, Base.Vector(3, 0, 0), Base.Vector(0, 1, 0))
plane.BoundBox
> BoundBox (3, 0, 0, 5, 0, 2)

BoundBox is a cuboid enclosing the plane with a diagonal starting at (3, 0, 0) and ending at (5, 0, 2). Here the BoundBox thickness along the Y axis is zero, since our shape is totally flat.

Note: makePlane() only accepts Base.Vector() for start_pnt and dir_normal and not tuples.

top

Creating an ellipse

There are several ways to create an ellipse:

Part.Ellipse()

Creates an ellipse with major radius 2 and minor radius 1 with the center at (0, 0, 0).

Part.Ellipse(Ellipse)

Creates a copy of the given ellipse.

Part.Ellipse(S1, S2, Center)

Creates an ellipse centered on the point Center, where the plane of the ellipse is defined by Center, S1 and S2, its major axis is defined by Center and S1, its major radius is the distance between Center and S1, and its minor radius is the distance between S2 and the major axis.

Part.Ellipse(Center, MajorRadius, MinorRadius)

Creates an ellipse with major and minor radii MajorRadius and MinorRadius, located in the plane defined by Center and the normal (0, 0, 1)

eli = Part.Ellipse(Base.Vector(10, 0, 0), Base.Vector(0, 5, 0), Base.Vector(0, 0, 0))
Part.show(eli.toShape())

In the above code we have passed S1, S2 and center. Similar to Arc, Ellipse creates an ellipse object not an edge, so we need to convert it into an edge using toShape() for display.

Note: Ellipse() only accepts Base.Vector() for points and not tuples.

eli = Part.Ellipse(Base.Vector(0, 0, 0), 10, 5)
Part.show(eli.toShape())

For the above Ellipse constructor we have passed center, MajorRadius and MinorRadius.

top

Creating a torus

Using makeTorus(radius1, radius2, [pnt, dir, angle1, angle2, angle]). By default pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1), angle1 = 0, angle2 = 360 and angle = 360. Consider a torus as small circle sweeping along a big circle. Radius1 is the radius of the big circle, radius2 is the radius of the small circle, pnt is the center of the torus and dir is the normal direction. angle1 and angle2 are angles in degrees for the small circle; the last angle parameter is to make a section of the torus:

torus = Part.makeTorus(10, 2)

The above code will create a torus with diameter 20 (radius 10) and thickness 4 (small circle radius 2)

tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)

The above code will create a slice of the torus.

tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 360, 180)

The above code will create a semi torus; only the last parameter is changed. i.e the remaining angles are defaults. Giving the angle 180 will create the torus from 0 to 180, that is, a half torus.

top

Creating a box or cuboid

Using makeBox(length, width, height, [pnt, dir]). By default pnt = Vector(0, 0, 0) and dir = Vector(0, 0, 1).

box = Part.makeBox(10, 10, 10)
len(box.Vertexes)
> 8

top

Creating a sphere

Using makeSphere(radius, [pnt, dir, angle1, angle2, angle3]). By default pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1), angle1 = -90, angle2 = 90 and angle3 = 360. angle1 and angle2 are the vertical minimum and maximum of the sphere, angle3 is the sphere diameter.

sphere = Part.makeSphere(10)
hemisphere = Part.makeSphere(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), -90, 90, 180)

top

Creating a cylinder

Using makeCylinder(radius, height, [pnt, dir, angle]). By default pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1) and angle = 360.

cylinder = Part.makeCylinder(5, 20)
partCylinder = Part.makeCylinder(5, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)

top

Creating a cone

Using makeCone(radius1, radius2, height, [pnt, dir, angle]). By default pnt = Vector(0, 0, 0), dir = Vector(0, 0, 1) and angle = 360.

cone = Part.makeCone(10, 0, 20)
semicone = Part.makeCone(10, 0, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)

top

Modifying shapes

There are several ways to modify shapes. Some are simple transformation operations such as moving or rotating shapes, others are more complex, such as unioning and subtracting one shape from another.

top

Transform operations

Translating a shape

Translating is the act of moving a shape from one place to another. Any shape (edge, face, cube, etc...) can be translated the same way:

myShape = Part.makeBox(2, 2, 2)
myShape.translate(Base.Vector(2, 0, 0))

This will move our shape "myShape" 2 units in the X direction.

top

Rotating a shape

To rotate a shape, you need to specify the rotation center, the axis, and the rotation angle:

myShape.rotate(Base.Vector(0, 0, 0),Base.Vector(0, 0, 1), 180)

The above code will rotate the shape 180 degrees around the Z Axis.

top

Generic transformations with matrices

A matrix is a very convenient way to store transformations in the 3D world. In a single matrix, you can set translation, rotation and scaling values to be applied to an object. For example:

myMat = Base.Matrix()
myMat.move(Base.Vector(2, 0, 0))
myMat.rotateZ(math.pi/2)

Note: FreeCAD matrixes work in radians. Also, almost all matrix operations that take a vector can also take three numbers, so these two lines do the same thing:

myMat.move(2, 0, 0)
myMat.move(Base.Vector(2, 0, 0))

Once our matrix is set, we can apply it to our shape. FreeCAD provides two methods for doing that: transformShape() and transformGeometry(). The difference is that with the first one, you are sure that no deformations will occur (see Scaling a shape below). We can apply our transformation like this:

myShape.transformShape(myMat)

or

myShape.transformGeometry(myMat)

top

Scaling a shape

Scaling a shape is a more dangerous operation because, unlike translation or rotation, scaling non-uniformly (with different values for X, Y and Z) can modify the structure of the shape. For example, scaling a circle with a higher value horizontally than vertically will transform it into an ellipse, which behaves mathematically very differently. For scaling, we cannot use the transformShape(), we must use transformGeometry():

myMat = Base.Matrix()
myMat.scale(2, 1, 1)
myShape=myShape.transformGeometry(myMat)

top

Boolean operations

Subtraction

Subtracting a shape from another one is called cut in FreeCAD and is done like this:

cylinder = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
sphere = Part.makeSphere(5, Base.Vector(5, 0, 0))
diff = cylinder.cut(sphere)

top

Intersection

The same way, the intersection between two shapes is called common and is done this way:

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
common = cylinder1.common(cylinder2)

top

Union

Union is called fuse and works the same way:

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
fuse = cylinder1.fuse(cylinder2)

top

Section

A section is the intersection between a solid shape and a plane shape. It will return an intersection curve, a compound curve composed of edges.

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
section = cylinder1.section(cylinder2)
section.Wires
> []
section.Edges
> [<Edge object at 0D87CFE8>, <Edge object at 019564F8>, <Edge object at 0D998458>, 
 <Edge  object at 0D86DE18>, <Edge object at 0D9B8E80>, <Edge object at 012A3640>, 
 <Edge object at 0D8F4BB0>]

top

Extrusion

Extrusion is the act of "pushing" a flat shape in a certain direction, resulting in a solid body. Think of a circle becoming a tube by "pushing it out":

circle = Part.makeCircle(10)
tube = circle.extrude(Base.Vector(0, 0, 2))

If your circle is hollow, you will obtain a hollow tube. If your circle is actually a disc with a filled face, you will obtain a solid cylinder:

wire = Part.Wire(circle)
disc = Part.Face(wire)
cylinder = disc.extrude(Base.Vector(0, 0, 2))

top

Exploring shapes

You can easily explore the topological data structure:

import Part
b = Part.makeBox(100, 100, 100)
b.Wires
w = b.Wires[0]
w
w.Wires
w.Vertexes
Part.show(w)
w.Edges
e = w.Edges[0]
e.Vertexes
v = e.Vertexes[0]
v.Point

By typing the lines above in the Python interpreter, you will gain a good understanding of the structure of Part objects. Here, our makeBox() command created a solid shape. This solid, like all Part solids, contains faces. Faces always contain wires, which are lists of edges that border the face. Each face has at least one closed wire (it can have more if the face has a hole). In the wire, we can look at each edge separately, and inside each edge, we can see the vertices. Straight edges have only two vertices, obviously.

top

Edge analysis

In case of an edge, which is an arbitrary curve, it's most likely you want to do a discretization. In FreeCAD the edges are parametrized by their lengths. That means you can walk an edge/curve by its length:

import Part
box = Part.makeBox(100, 100, 100)
anEdge = box.Edges[0]
print(anEdge.Length)

Now you can access a lot of properties of the edge by using the length as a position. That means if the edge is 100mm long the start position is 0 and the end position 100.

anEdge.tangentAt(0.0)          # tangent direction at the beginning
anEdge.valueAt(0.0)            # Point at the beginning
anEdge.valueAt(100.0)          # Point at the end of the edge
anEdge.derivative1At(50.0)     # first derivative of the curve in the middle
anEdge.derivative2At(50.0)     # second derivative of the curve in the middle
anEdge.derivative3At(50.0)     # third derivative of the curve in the middle
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.curvatureAt(50.0)       # the curvature
anEdge.normalAt(50)            # normal vector at that position (if defined)

top

Using the selection

Here we see now how we can use the selection the user did in the viewer. First of all we create a box and show it in the viewer.

import Part
Part.show(Part.makeBox(100, 100, 100))
Gui.SendMsgToActiveView("ViewFit")

Now select some faces or edges. With this script you can iterate over all selected objects and their sub elements:

for o in Gui.Selection.getSelectionEx():
    print(o.ObjectName)
    for s in o.SubElementNames:
        print("name: ", s)
        for s in o.SubObjects:
            print("object: ", s)

Select some edges and this script will calculate the length:

length = 0.0
for o in Gui.Selection.getSelectionEx():
    for s in o.SubObjects:
        length += s.Length

print("Length of the selected edges: ", length)

top

Complete example: The OCC bottle

A typical example found in the OpenCasCade Technology Tutorial is how to build a bottle. This is a good exercise for FreeCAD too. In fact, if you follow our example below and the OCC page simultaneously, you will see how well OCC structures are implemented in FreeCAD. The complete script below is also included in the FreeCAD installation (inside the Mod/Part folder) and can be called from the Python interpreter by typing:

import Part
import MakeBottle
bottle = MakeBottle.makeBottle()
Part.show(bottle)

top

The complete script

Here is the complete MakeBottle script:

import Part, FreeCAD, math
from FreeCAD import Base

def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
   aPnt1=Base.Vector(-myWidth/2.,0,0)
   aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
   aPnt3=Base.Vector(0,-myThickness/2.,0)
   aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
   aPnt5=Base.Vector(myWidth/2.,0,0)
   
   aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
   aSegment1=Part.LineSegment(aPnt1,aPnt2)
   aSegment2=Part.LineSegment(aPnt4,aPnt5)
   aEdge1=aSegment1.toShape()
   aEdge2=aArcOfCircle.toShape()
   aEdge3=aSegment2.toShape()
   aWire=Part.Wire([aEdge1,aEdge2,aEdge3])
   
   aTrsf=Base.Matrix()
   aTrsf.rotateZ(math.pi) # rotate around the z-axis
   
   aMirroredWire=aWire.transformGeometry(aTrsf)
   myWireProfile=Part.Wire([aWire,aMirroredWire])
   myFaceProfile=Part.Face(myWireProfile)
   aPrismVec=Base.Vector(0,0,myHeight)
   myBody=myFaceProfile.extrude(aPrismVec)
   myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)
   neckLocation=Base.Vector(0,0,myHeight)
   neckNormal=Base.Vector(0,0,1)
   myNeckRadius = myThickness / 4.
   myNeckHeight = myHeight / 10
   myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)	
   myBody = myBody.fuse(myNeck)
   
   faceToRemove = 0
   zMax = -1.0
   
   for xp in myBody.Faces:
       try:
           surf = xp.Surface
           if type(surf) == Part.Plane:
               z = surf.Position.z
               if z > zMax:
                   zMax = z
                   faceToRemove = xp
       except:
           continue
   
   myBody = myBody.makeFillet(myThickness/12.0,myBody.Edges)
   
   return myBody

el = makeBottle()
Part.show(el)

top

Detailed explanation

import math
import Part
import FreeCAD
from FreeCAD import Base

We will need, of course, the Part module, but also the FreeCAD.Base module, which contains basic FreeCAD structures like vectors and matrices.

def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
    aPnt1 = Base.Vector(-myWidth/2.,0,0)
    aPnt2 = Base.Vector(-myWidth/2.,-myThickness/4.,0)
    aPnt3 = Base.Vector(0,-myThickness/2.,0)
    aPnt4 = Base.Vector(myWidth/2.,-myThickness/4.,0)
    aPnt5 = Base.Vector(myWidth/2.,0,0)

Here we define our makeBottle function. This function can be called without arguments, like we did above, in which case default values for width, height, and thickness will be used. Then, we define a couple of points that will be used for building our base profile.

...
    aArcOfCircle = Part.Arc(aPnt2,aPnt3, aPnt4)
    aSegment1 = Part.LineSegment(aPnt1, aPnt2)
    aSegment2 = Part.LineSegment(aPnt4, aPnt5)

Here we actually define the geometry: an arc, made of three points, and two line segments, made of two points.

...
    aEdge1 = aSegment1.toShape()
    aEdge2 = aArcOfCircle.toShape()
    aEdge3 = aSegment2.toShape()
    aWire = Part.Wire([aEdge1, aEdge2, aEdge3])

Remember the difference between geometry and shapes? Here we build shapes out of our construction geometry. Three edges (edges can be straight or curved), then a wire made of those three edges.

...
    aTrsf = Base.Matrix()
    aTrsf.rotateZ(math.pi) # rotate around the z-axis
    aMirroredWire = aWire.transformGeometry(aTrsf)
    myWireProfile = Part.Wire([aWire, aMirroredWire])

So far we have built only a half profile. Instead of building the whole profile the same way, we can just mirror what we did and glue both halves together. We first create a matrix. A matrix is a very common way to apply transformations to objects in the 3D world, since it can contain in one structure all basic transformations that 3D objects can undergo (move, rotate and scale). After we create the matrix we mirror it, then we create a copy of our wire with that transformation matrix applied to it. We now have two wires, and we can make a third wire out of them, since wires are actually lists of edges.

...
    myFaceProfile = Part.Face(myWireProfile)
    aPrismVec = Base.Vector(0,0,myHeight)
    myBody = myFaceProfile.extrude(aPrismVec)
    myBody = myBody.makeFillet(myThickness/12.0,myBody.Edges)

Now that we have a closed wire, it can be turned into a face. Once we have a face, we can extrude it. In doing so, we make a solid. Then we apply a nice little fillet to our object because we care about good design, don't we?

...
    neckLocation = Base.Vector(0, 0, myHeight)
    neckNormal = Base.Vector(0, 0, 1)
    myNeckRadius = myThickness / 4.0
    myNeckHeight = myHeight / 10
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)

At this point, the body of our bottle is made, but we still need to create a neck. So we make a new solid, with a cylinder.

...
    myBody = myBody.fuse(myNeck)

The fuse operation, which in other applications is sometimes called a union, is very powerful. It will take care of gluing what needs to be glued and remove parts that need to be removed.

...
    return myBody

Then, we return our Part solid as the result of our function.

el = makeBottle()
Part.show(el)

Finally, we call the function to actually create the part, then make it visible.

top

Box pierced

Here is a complete example of building a pierced box.

The construction is done one side at a time; when the cube is finished, it is hollowed out by cutting a cylinder through it.

import Draft, Part, FreeCAD, math, PartGui, FreeCADGui, PyQt4
from math import sqrt, pi, sin, cos, asin
from FreeCAD import Base

size = 10
poly = Part.makePolygon( [ (0,0,0), (size, 0, 0), (size, 0, size), (0, 0, size), (0, 0, 0)])

face1 = Part.Face(poly)
face2 = Part.Face(poly)
face3 = Part.Face(poly)
face4 = Part.Face(poly)
face5 = Part.Face(poly)
face6 = Part.Face(poly)
     
myMat = FreeCAD.Matrix()
myMat.rotateZ(math.pi/2)
face2.transformShape(myMat)
face2.translate(FreeCAD.Vector(size, 0, 0))

myMat.rotateZ(math.pi/2)
face3.transformShape(myMat)
face3.translate(FreeCAD.Vector(size, size, 0))

myMat.rotateZ(math.pi/2)
face4.transformShape(myMat)
face4.translate(FreeCAD.Vector(0, size, 0))

myMat = FreeCAD.Matrix()
myMat.rotateX(-math.pi/2)
face5.transformShape(myMat)

face6.transformShape(myMat)               
face6.translate(FreeCAD.Vector(0,0,size))

myShell = Part.makeShell([face1,face2,face3,face4,face5,face6])   

mySolid = Part.makeSolid(myShell)
mySolidRev = mySolid.copy()
mySolidRev.reverse()

myCyl = Part.makeCylinder(2,20)
myCyl.translate(FreeCAD.Vector(size/2, size/2, 0))

cut_part = mySolidRev.cut(myCyl)

Part.show(cut_part)

top

Loading and saving

There are several ways to save your work in the Part module. You can of course save your FreeCAD document, but you can also save Part objects directly to common CAD formats, such as BREP, IGS, STEP and STL.

Saving a shape to a file is easy. There are exportBrep(), exportIges(), exportStl() and exportStep() methods available for all shape objects. So, doing:

import Part
s = Part.makeBox(0,0,0,10,10,10)
s.exportStep("test.stp")

will save our box into a STEP file. To load a BREP, IGES or STEP file:

import Part
s = Part.Shape()
s.read("test.stp")

To convert an .stp file to an .igs file:

import Part
 s = Part.Shape()
 s.read("file.stp")       # incoming file igs, stp, stl, brep
 s.exportIges("file.igs") # outbound file igs

Note that importing or opening BREP, IGES or STEP files can also be done directly from the File → Open or File → Import menu, while exporting can be done with File → Export.

top